* -------------------------------------------------------------------------------
* Adrian Parnham - Simply GUI Ltd  - 100667,646@compuserve.com
* -------------------------------------------------------------------------------
* NEW_CURS.PRG - (FPW26) - call this program with a .dbf open and a formatted
*                "create cursor" command is produced (when viewed in a 
*                non-proportional font) in new_curs.txt, which may be modified
*                and placed in your code. 
* -------------------------------------------------------------------------------
* This program is freeware and may be distributed or modified as one wishes.
* Absolutely no liability whatsoever is accepted by the author.
* -------------------------------------------------------------------------------
PRIVATE indent, max_fields, startstr, fieldstr, n

indent=4
max_fields=4

handle=FCREATE('new_curs.txt')

=AFIELDS(allfields)

startstr='CREATE CURSOR new_curs (;' + chr(13) + space(indent)
=FWRITE(handle, startstr)

FOR N=1 TO ALEN(allfields,1)


   fieldstr=""
   fieldstr=fieldstr + LOWER(allfields(N,1)) + SPACE(11-LEN(allfields(N,1)))   && field name

   DO CASE                                                                     && field attributes

      CASE allfields(N,2)='C'                                                  && character fields
         fieldstr=fieldstr + 'C('+LTRIM(STR(allfields(N,3),3))+')'

      CASE allfields(N,2)$'DLMGP'                                              && date, logical, memo, general, picture
         fieldstr=fieldstr + allfields(N,2)

      CASE allfields(N,2)$'NF'                                                 && numeric, float
         fieldstr=fieldstr + 'N(' + LTRIM(STR(allfields(N,3),3)) + ',' + ;
                  LTRIM(STR(allfields(N,4),3)) + ')'

   ENDCASE

   =FWRITE(handle, fieldstr + SPACE(19-LEN(fieldstr)))

   IF N<ALEN(allfields,1)
      IF MOD(N,max_fields)=0
         =FWRITE(handle, ",;" + CHR(13) + space(indent))
      ELSE
         =FWRITE(handle, ", ")                                             && comma separation of fields
      ENDIF
   ENDIF

NEXT

=FWRITE(handle, ")" )                   && end of cursor
=FCLOSE(handle)

* eof
